//------------------------------------------------------------------------------
//
// DA Checkers - Winner/Looser Dialog
//
// Copyright (c) 2005 Kambiz R. Khojasteh
// All rights reserved.
//
//------------------------------------------------------------------------------

unit dlgFinish;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GameBoard, StdCtrls, ExtCtrls;

type
  TGameFinishDialog = class(TForm)
    Description1: TLabel;
    Description2: TLabel;
    btnYes: TButton;
    btnNo: TButton;
    HumanWon: TImage;
    ComputerWon: TImage;
    Finish: TImage;
  public
    class function Execute(Winner, Computer: TPlayer): Boolean;
  end;

implementation

{$R *.dfm}

resourcestring
  SDraw        = 'The game is draw!';
  SDarkWon     = 'Red Player Won!';
  SLightWon    = 'White Player Won!';
  SHumanWon    = 'Congratulations, you won!';
  SComputerWon = 'Sorry, you lost!';

{ TGameFinishDialog }

class function TGameFinishDialog.Execute(Winner, Computer: TPlayer): Boolean;
begin
  with Create(Application) do
    try
      if (Computer in [NONE, BOTH_PLAYERS]) or (Winner in [NONE, BOTH_PLAYERS]) then
      begin
        case Winner of
          DARK_PLAYER: Description1.Caption := SDarkWon;
          LIGHT_PLAYER: Description1.Caption := SLightWon;
        else
          Description1.Caption := SDraw;
        end;
        Finish.Visible := True;
      end
      else if Winner = Computer then
      begin
        Description1.Caption := SComputerWon;
        ComputerWon.Visible := True;
      end
      else
      begin
        Description1.Caption := SHumanWon;
        HumanWon.Visible := True;
      end;
      Result := (ShowModal = mrYes);
    finally
      Free;
    end;
end;

end.
