//------------------------------------------------------------------------------
//
// DA Checkers - Memory Options Dialog
//
// Copyright (c) 2005 Kambiz R. Khojasteh
// All rights reserved.
//
//------------------------------------------------------------------------------

unit dlgMemory;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, GameBoard;

const
  OneMB = 1 * 1024 * 1024;

type
  TMemoryOptionsDialog = class(TForm)
    IconMemory: TImage;
    Description1: TLabel;
    btnCancel: TButton;
    btnYes: TButton;
    MaxLabel: TLabel;
    MaxEdit: TEdit;
    Max: TUpDown;
    MaxMB: TLabel;
    Bevel2: TBevel;
    procedure FormCreate(Sender: TObject);
  public
    class function Execute(var MaxSize: Cardinal): Boolean;
  end;

implementation

{$R *.dfm}

{ TMemoryOptionsDialog }

class function TMemoryOptionsDialog.Execute(var MaxSize: Cardinal): Boolean;
begin
  Result := False;
  with Create(Application) do
    try
      Max.Position := MaxSize;
      if ShowModal = mrOK then
      begin
        MaxSize := Max.Position;
        Result := True;
      end;
    finally
      Free;
    end;
end;

procedure TMemoryOptionsDialog.FormCreate(Sender: TObject);
var
  MemoryStatus: TMemoryStatus;
begin
  MemoryStatus.dwLength := SizeOf(MemoryStatus);
  GlobalMemoryStatus(MemoryStatus);
  Max.Max := MemoryStatus.dwTotalPhys div OneMB;
end;

end.
