//------------------------------------------------------------------------------
//
// DA Othello - Application's Main Window
//
// Copyright (c) 2005 Kambiz R. Khojasteh
// All rights reserved.
//
//------------------------------------------------------------------------------

unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, XPMan, ActnList, StdCtrls, ComCtrls, ExtCtrls, ImgList,
  ToolWin, Buttons, Gameboard, OthelloBoard, AppEvnts, jpeg;

type
  TMainForm = class(TForm)
    GameHost: TPanel;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ActionList: TActionList;
    GameNew: TAction;
    GameSave: TAction;
    GameOpen: TAction;
    HistoryFoward: TAction;
    HistoryBackward: TAction;
    ComputerPlaysBlack: TAction;
    ComputerPlaysWhite: TAction;
    LevelEasy: TAction;
    LevelMedium: TAction;
    LevelDifficult: TAction;
    MainMenu: TMainMenu;
    Game1: TMenuItem;
    Computer1: TMenuItem;
    View1: TMenuItem;
    Help1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    SaveAs1: TMenuItem;
    GameExit: TAction;
    Exit1: TMenuItem;
    HelpAbout: TAction;
    N2: TMenuItem;
    Easy1: TMenuItem;
    Easy2: TMenuItem;
    Difficult1: TMenuItem;
    About1: TMenuItem;
    History1: TMenuItem;
    MoveBackward1: TMenuItem;
    MoveForward1: TMenuItem;
    ComputerPlayNow: TAction;
    PlayNow1: TMenuItem;
    HistoryShow: TAction;
    N4: TMenuItem;
    ShowHistory1: TMenuItem;
    StateInfo: TPanel;
    N5: TMenuItem;
    BoardSize1: TMenuItem;
    BoardSizeSmall: TAction;
    BoardSizeMedium: TAction;
    BoardSizeLarge: TAction;
    Small1: TMenuItem;
    Medium1: TMenuItem;
    Large1: TMenuItem;
    Level1: TMenuItem;
    Timer: TTimer;
    ThinkIcons: TImageList;
    LeftSpacer: TBevel;
    RightSpacer: TBevel;
    State: TLabel;
    HistoryMoveToBlack: TAction;
    HistoryPopupMenu: TPopupMenu;
    MoveToSelected1: TMenuItem;
    ComputerSuggest: TAction;
    N7: TMenuItem;
    SuggestMove1: TMenuItem;
    ControlPause: TAction;
    ControlResume: TAction;
    ComputerPlaysNone: TAction;
    ComputerPlaysBoth: TAction;
    PlaysAs1: TMenuItem;
    None1: TMenuItem;
    BlackPlayer1: TMenuItem;
    WhitePlayer1: TMenuItem;
    Both1: TMenuItem;
    GameSetupBoard: TAction;
    N3: TMenuItem;
    BoardSetupBar: TToolBar;
    btnBlackPiece: TToolButton;
    btnWhitePiece: TToolButton;
    ToolButton1: TToolButton;
    btnBlackTurn: TToolButton;
    btnWhiteTurn: TToolButton;
    PieceImages: TImageList;
    SuggestionCommands: TPanel;
    btnPlaySelection: TButton;
    btnClearSelection: TButton;
    TimePanel: TPanel;
    btnPause: TSpeedButton;
    btnResume: TSpeedButton;
    ThinkIcon: TPaintBox;
    ElapsedTime: TLabel;
    btnClearBoard: TToolButton;
    ToolButton3: TToolButton;
    HistoryMoveToWhite: TAction;
    WhiteMoveBackHere1: TMenuItem;
    HistoryPanel: TPanel;
    History: TListView;
    HistoryTime: TPanel;
    Label1: TLabel;
    Time1: TLabel;
    Time2: TLabel;
    ViewSelectablePositions: TAction;
    ApplicationEvents: TApplicationEvents;
    Control1: TMenuItem;
    Pause1: TMenuItem;
    Resume1: TMenuItem;
    HelpRules: TAction;
    heBasicRulesofOthello1: TMenuItem;
    LevelCustom: TAction;
    Custom1: TMenuItem;
    N8: TMenuItem;
    SetupBoard1: TMenuItem;
    ClientPanel: TPanel;
    ToolbarImages: TImageList;
    Toolbar: TToolBar;
    ToolButton2: TToolButton;
    ViewToolbar: TAction;
    N11: TMenuItem;
    Toolbar1: TMenuItem;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    DisabledToolbarImages: TImageList;
    HotToolbarImages: TImageList;
    HistoryShowTimes: TAction;
    ShowTimes1: TMenuItem;
    DummyImageLIst: TImageList;
    ViewFullScreen: TAction;
    FullScreen1: TMenuItem;
    ControlEnableSounds: TAction;
    EnableSounds1: TMenuItem;
    HelpHomePage: TAction;
    DAOthelloHomePage1: TMenuItem;
    N14: TMenuItem;
    HistoryFirst: TAction;
    HistoryLast: TAction;
    FirstMove1: TMenuItem;
    LastMove1: TMenuItem;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    N15: TMenuItem;
    Rotate000: TAction;
    Rotate090: TAction;
    Rotate180: TAction;
    Rotate270: TAction;
    BoardAngle1: TMenuItem;
    N01: TMenuItem;
    N901: TMenuItem;
    N1801: TMenuItem;
    N2701: TMenuItem;
    GameMemoryOptions: TAction;
    N9: TMenuItem;
    MemoryOptions1: TMenuItem;
    RotateClockwise: TAction;
    RotateConterClockwise: TAction;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton15: TToolButton;
    Game: TOthello;
    TurnIcon: TImage;
    SetupCommands: TPanel;
    btnApplyChanges: TButton;
    btnRevertChanges: TButton;
    btnNoMove: TButton;
    PiecesCount: TLabel;
    N1: TMenuItem;
    MarkSelectablePositions1: TMenuItem;
    HistoryCopy: TAction;
    N6: TMenuItem;
    CopytoClipboard1: TMenuItem;
    N10: TMenuItem;
    CopytoClipboard2: TMenuItem;
    procedure HistoryCopyExecute(Sender: TObject);
    procedure HistoryCopyUpdate(Sender: TObject);
    procedure GameBoardChange(Sender: TObject);
    procedure btnNoMoveClick(Sender: TObject);
    procedure RotateConterClockwiseExecute(Sender: TObject);
    procedure RotateClockwiseExecute(Sender: TObject);
    procedure GameMemoryOptionsExecute(Sender: TObject);
    procedure Rotate270Execute(Sender: TObject);
    procedure Rotate270Update(Sender: TObject);
    procedure Rotate180Execute(Sender: TObject);
    procedure Rotate180Update(Sender: TObject);
    procedure Rotate090Execute(Sender: TObject);
    procedure Rotate090Update(Sender: TObject);
    procedure Rotate000Execute(Sender: TObject);
    procedure Rotate000Update(Sender: TObject);
    procedure HistoryLastExecute(Sender: TObject);
    procedure HistoryLastUpdate(Sender: TObject);
    procedure HistoryFirstExecute(Sender: TObject);
    procedure HistoryFirstUpdate(Sender: TObject);
    procedure GameTurnChange(Sender: TObject);
    procedure HistoryCustomDrawSubItem(Sender: TCustomListView; Item: TListItem;
      SubItem: Integer; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure HelpHomePageExecute(Sender: TObject);
    procedure ActiveScreenFormChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ControlEnableSoundsExecute(Sender: TObject);
    procedure GameNullMove(Sender: TObject);
    procedure GameMove(Sender: TObject; Pos: TPosition);
    procedure ApplicationEventsDeactivate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ViewFullScreenExecute(Sender: TObject);
    procedure HistoryShowTimesExecute(Sender: TObject);
    procedure ViewToolbarExecute(Sender: TObject);
    procedure ViewToolbarUpdate(Sender: TObject);
    procedure LevelCustomExecute(Sender: TObject);
    procedure LevelCustomUpdate(Sender: TObject);
    procedure HelpRulesExecute(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure ViewSelectablePositionsExecute(Sender: TObject);
    procedure ViewSelectablePositionsUpdate(Sender: TObject);
    procedure HistoryMoveToWhiteExecute(Sender: TObject);
    procedure HistoryMoveToWhiteUpdate(Sender: TObject);
    procedure ThinkIconPaint(Sender: TObject);
    procedure btnClearBoardClick(Sender: TObject);
    procedure GameSetupBoardUpdate(Sender: TObject);
    procedure btnRevertChangesClick(Sender: TObject);
    procedure btnApplyChangesClick(Sender: TObject);
    procedure GameSetupBoardExecute(Sender: TObject);
    procedure HistoryCustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ComputerPlaysBothExecute(Sender: TObject);
    procedure ComputerPlaysBothUpdate(Sender: TObject);
    procedure ComputerPlaysNoneExecute(Sender: TObject);
    procedure ComputerPlaysNoneUpdate(Sender: TObject);
    procedure ControlResumeExecute(Sender: TObject);
    procedure ControlResumeUpdate(Sender: TObject);
    procedure ControlPauseExecute(Sender: TObject);
    procedure ControlPauseUpdate(Sender: TObject);
    procedure btnClearSelectionClick(Sender: TObject);
    procedure btnPlaySelectionClick(Sender: TObject);
    procedure ComputerSuggestExecute(Sender: TObject);
    procedure ComputerSuggestUpdate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HistoryMoveToBlackExecute(Sender: TObject);
    procedure HistoryMoveToBlackUpdate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure ClientPanelResize(Sender: TObject);
    procedure BoardSizeLargeExecute(Sender: TObject);
    procedure BoardSizeLargeUpdate(Sender: TObject);
    procedure BoardSizeMediumExecute(Sender: TObject);
    procedure BoardSizeMediumUpdate(Sender: TObject);
    procedure BoardSizeSmallExecute(Sender: TObject);
    procedure BoardSizeSmallUpdate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCanResize(Sender: TObject; var NewWidth, NewHeight: Integer;
      var Resize: Boolean);
    procedure HistoryShowExecute(Sender: TObject);
    procedure HistoryShowUpdate(Sender: TObject);
    procedure ComputerPlayNowExecute(Sender: TObject);
    procedure ComputerPlayNowUpdate(Sender: TObject);
    procedure ComputerPlaysWhiteExecute(Sender: TObject);
    procedure ComputerPlaysWhiteUpdate(Sender: TObject);
    procedure ComputerPlaysBlackExecute(Sender: TObject);
    procedure ComputerPlaysBlackUpdate(Sender: TObject);
    procedure LevelDifficultExecute(Sender: TObject);
    procedure LevelDifficultUpdate(Sender: TObject);
    procedure LevelMediumExecute(Sender: TObject);
    procedure LevelMediumUpdate(Sender: TObject);
    procedure LevelEasyExecute(Sender: TObject);
    procedure LevelEasyUpdate(Sender: TObject);
    procedure HistoryBackwardExecute(Sender: TObject);
    procedure HistoryBackwardUpdate(Sender: TObject);
    procedure HistoryFowardExecute(Sender: TObject);
    procedure HistoryFowardUpdate(Sender: TObject);
    procedure HelpAboutExecute(Sender: TObject);
    procedure GameExitExecute(Sender: TObject);
    procedure GameOpenExecute(Sender: TObject);
    procedure GameSaveExecute(Sender: TObject);
    procedure GameNewExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GamePositionClick(Sender: TObject; Pos: TPosition;
      var Handled: Boolean);
    procedure GameHistoryChange(Sender: TObject);
    procedure GameSelectionChange(Sender: TObject);
    procedure GameThinkEnd(Sender: TObject);
    procedure GamePlayingStateChange(Sender: TObject);
    procedure GameBoardModeChange(Sender: TObject);
    procedure GameEnded(Sender: TObject);
    procedure GameResize(Sender: TObject);
  private
    Opener: TPlayer;
    PausedByDialog: Boolean;
    ThinkIconIndex: Integer;
    BoardStream: TMemoryStream;
    FullScreenMode: Boolean;
    ShowHistory: Boolean;
    procedure ReleaseGame(const FileName: String);
    procedure SetFullScreen(SetOn: Boolean);
    function IsGameSaved: Boolean;
    procedure UpdateTitle;
    procedure UpdateState;
    procedure UpdateHistory;
    procedure LoadSettings;
    procedure SaveSettings;
    function MatchAsString: String;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}
{$R Sounds.res}

uses
  Registry, ShellAPI, mmSystem, Clipbrd, dlgAbout, dlgSearchDepth,
  dlgSaveQuery, dlgFinish, dlgMemory, Types;

resourcestring
  SBlackTurn       = 'Black player''s turn...';
  SWhiteTurn       = 'White player''s turn...';
  SBlackWon        = 'Black player won!';
  SWhiteWon        = 'White player won!';
  SDraw            = 'Game is draw!';
  SHuman           = 'Human';
  SComputer        = 'Computer';
  SMatchPlayers    = '%s vs. %s';
  SBoardSetup      = 'Board Setup';
  SLevelEasy       = 'Easy';
  SLevelMedium     = 'Medium';
  SLevelDifficult  = 'Difficult';
  SPiecesCount     = 'Black Pieces:  %u     White Pieces:  %u';

const
  SearchDepths: array[1..3] of Integer = (4, 8, 12);
  SquareSizes: array[1..3] of Integer = (40, 50, 60);

{ Helper Functions }

function MillisecondsToStr(MS: Cardinal; ShowHours: Boolean): String;
var
  Hours, Minutes, Seconds: Cardinal;
begin
  Seconds := (MS + 500) div 1000;
  Minutes := Seconds div 60;
  Dec(Seconds, Minutes * 60);
  if ShowHours then
  begin
    Hours := Minutes div 60;
    Dec(Minutes, Hours * 60);
    Result := Format('%u:%2.2u:%2.2u', [Hours, Minutes, Seconds])
  end
  else
    Result := Format('%2.2u:%2.2u', [Minutes, Seconds]);
end;

{ TMainForm }

procedure TMainForm.ReleaseGame(const FileName: String);
var
  F: TextFile;
begin
  AssignFile(F, FileName);
  if not FileExists(FileName) then
    Rewrite(F)
  else
    Append(F);
  Writeln(F, MatchAsString);
  CloseFile(F);
end;

procedure TMainForm.LoadSettings;
var
  R: TRegistry;
begin
  ShowHistory := HistoryPanel.Visible;
  R := TRegistry.Create;
  try
    if R.OpenKeyReadOnly('\SOFTWARE\DELPHI AREA\' + Application.Title) then
    begin
      if R.ValueExists('Window Left') then
        Left := R.ReadInteger('Window Left');
      if R.ValueExists('Window Top') then
        Top := R.ReadInteger('Window Top');
      if R.ValueExists('Toolbar') then
        Toolbar.Visible := R.ReadBool('Toolbar');
      if R.ValueExists('Show History') then
      begin
        ShowHistory := R.ReadBool('Show History');
        HistoryPanel.Visible := ShowHistory;
      end;
      if R.ValueExists('Show History Time') then
        HistoryShowTimes.Checked := R.ReadBool('Show History Time');
      if R.ValueExists('Computer Player') then
        Game.ComputerPlayer := R.ReadInteger('Computer Player');
      if R.ValueExists('Search Depth') then
        Game.SearchDepth := R.ReadInteger('Search Depth');
      if R.ValueExists('Mark Selectable Positions') then
        Game.MarkSelectableSquares := R.ReadBool('Mark Selectable Positions');
      if R.ValueExists('Board Angle') then
        Game.BoardAngle := R.ReadInteger('Board Angle');
      if R.ValueExists('Board Square Size') then
        Game.SquareSize := R.ReadInteger('Board Square Size');
      if R.ValueExists('Enable Sounds') then
        ControlEnableSounds.Checked := R.ReadBool('Enable Sounds');
      if R.ValueExists('Max Memory') then
        Game.MaxMemory := R.ReadInteger('Max Memory');
      R.CloseKey;
    end;
  finally
    R.Free;
  end;
end;

procedure TMainForm.SaveSettings;
var
  R: TRegistry;
begin
  R := TRegistry.Create;
  try
    if R.OpenKey('\SOFTWARE\DELPHI AREA\' + Application.Title, True) then
    begin
      R.WriteInteger('Window Left', Left);
      R.WriteInteger('Window Top', Top);
      R.WriteBool('Toolbar', Toolbar.Visible);
      R.WriteBool('Show History', ShowHistory);
      R.WriteBool('Show History Time', HistoryShowTimes.Checked);
      R.WriteInteger('Computer Player', Game.ComputerPlayer);
      R.WriteInteger('Search Depth', Game.SearchDepth);
      R.WriteBool('Mark Selectable Positions', Game.MarkSelectableSquares);
      R.WriteInteger('Board Angle', Game.BoardAngle);
      R.WriteInteger('Board Square Size', Game.SquareSize);
      R.WriteBool('Enable Sounds', ControlEnableSounds.Checked);
      R.WriteInteger('Max Memory', Game.MaxMemory);
      R.CloseKey;
    end;
  finally
    R.Free;
  end;
end;

procedure TMainForm.SetFullScreen(SetOn: Boolean);
begin
  if FullScreenMode <> SetOn then
  begin
    FullScreenMode := SetOn;
    if FullScreenMode then
    begin
      Game.Font.Color := clWhite;
      Game.BoardMarginColor := clBlack;
      Game.BoardBorderColor := clNone;
      Game.Tag := Game.SquareSize;
      Game.AutoSize := False;
      Game.FixedSquareSize := False;
      Windows.SetParent(Game.Handle, 0);
      with Monitor.BoundsRect do
        Windows.SetWindowPos(Game.Handle, HWND_TOPMOST, Left, Top,
          Right - Left, Bottom - Top, SWP_NOOWNERZORDER);
      TurnIcon.Visible := True;
    end
    else
    begin
      TurnIcon.Visible := False;
      Game.Font.Color := clBlack;
      Game.BoardMarginColor := clBtnFace;
      Game.BoardBorderColor := clBtnShadow;
      Game.FixedSquareSize := True;
      Game.SquareSize := Game.Tag;
      Windows.SetParent(Game.Handle, GameHost.Handle);
      Game.Top := StateInfo.Height;
      Game.AutoSize := True;
      AdjustSize;
    end;
  end;
end;

procedure TMainForm.UpdateState;
begin
  if Game.IsGameEnded then
    case Game.WinnerPlayer of
      BLACK: State.Caption := SBlackWon;
      WHITE: State.Caption := SWhiteWon;
    else
      State.Caption := SDraw;
    end
  else
    case Game.CurrentPlayer of
      BLACK: State.Caption := SBlackTurn;
      WHITE: State.Caption := SWhiteTurn;
    else
      State.Caption := '';
    end;
  StateInfo.Update;
end;

procedure TMainForm.UpdateTitle;
var
  Text: String;
  ComputerLevel: String;
begin
  if Game.BoardMode = gbmPlay then
  begin
    if Game.SearchDepth = SearchDepths[1] then
      ComputerLevel := Format('%s (%s)', [SComputer, SLevelEasy])
    else if Game.SearchDepth = SearchDepths[2] then
      ComputerLevel := Format('%s (%s)', [SComputer, SLevelMedium])
    else if Game.SearchDepth = SearchDepths[3] then
      ComputerLevel := Format('%s (%s)', [SComputer, SLevelDifficult])
    else
      ComputerLevel := Format('%s [%u]', [SComputer, Game.SearchDepth]);
    case Game.ComputerPlayer of
      NONE: Text := Format(SMatchPlayers, [SHuman, SHuman]);
      BLACK: Text := Format(SMatchPlayers, [ComputerLevel, SHuman]);
      WHITE: Text := Format(SMatchPlayers, [SHuman, ComputerLevel]);
    else
      Text := Format(SMatchPlayers, [ComputerLevel, ComputerLevel]);
    end;
  end
  else
    Text := SBoardSetup;
  Caption := Application.Title + ' - ' + Text;
end;

procedure TMainForm.UpdateHistory;
var
  TurnNo: Integer;
  Item: TListItem;
  P1, P2: TPlayer;
  M1, M2: String;
begin
  if Game.OpenerPlayer <> Opener then
  begin
    Opener := Game.OpenerPlayer;
    M1 := History.Columns[1].Caption;
    M2 := History.Columns[2].Caption;
    History.Columns[1].Caption := M2;
    History.Columns[2].Caption := M1;
  end;
  P1 := Game.OpenerPlayer;
  P2 := Opponent(Game.OpenerPlayer);
  for TurnNo := 1 to Game.PlayedTurns + 1 do
  begin
    M1 := Game.MoveOf(P1, TurnNo);
    if M1 = '' then Break;
    if HistoryShowTimes.Checked then
      M1 := M1 + '  (' + MillisecondsToStr(Game.TimeOf(P1, TurnNo), False) + ')';
    M2 := Game.MoveOf(P2, TurnNo);
    if HistoryShowTimes.Checked and (M2 <> '') then
      M2 := M2 + '  (' + MillisecondsToStr(Game.TimeOf(P2, TurnNo), False) + ')';
    if TurnNo > History.Items.Count then
    begin
      Item := History.Items.Add;
      Item.Caption := IntToStr(TurnNo);
    end
    else
      Item := History.Items[TurnNo - 1];
    if Item.SubItems.Count <= 0 then
      Item.SubItems.Add(M1)
    else if Item.SubItems[0] <> M1 then
      Item.SubItems[0] := M1;
    if Item.SubItems.Count <= 1 then
      Item.SubItems.Add(M2)
    else if Item.SubItems[1] <> M2 then
      Item.SubItems[1] := M2;
  end;
  while History.Items.Count > Game.PlayedTurns + 1 do
    History.Items.Delete(History.Items.Count - 1);
  if (History.Items.Count = Game.PlayedTurns + 1) and (Game.MoveOf(P1, Game.PlayedTurns + 1) = '') then
    History.Items.Delete(History.Items.Count - 1);
  if History.Items.Count >= Game.CurrentTurn then
    History.Items[Game.CurrentTurn - 1].MakeVisible(False);
  InvalidateRect(History.Handle, nil, False);
  Time1.Caption := MillisecondsToStr(Game.CurrentTimeOf[P1], True);
  Time2.Caption := MillisecondsToStr(Game.CurrentTimeOf[P2], True);
end;

function TMainForm.IsGameSaved: Boolean;
begin
  if Game.Modified then
    case TSaveQueryDialog.Execute of
      mrYes: GameSave.Execute;
      mrNo: Game.Modified := False;
    end;
  Result := not Game.Modified;
end;

function TMainForm.MatchAsString: String;
var
  TurnNo: Integer;
  M: String;
begin
  if Game.IsGameEnded then
    case Game.WinnerPlayer of
      BLACK: Result := Format('BLACK (%2.2d-%2.2d):', [Game.PieceCount[BLACK], Game.PieceCount[WHITE]]);
      WHITE: Result := Format('WHITE (%2.2d-%2.2d):', [Game.PieceCount[WHITE], Game.PieceCount[BLACK]]);
    else
      Result := Format('DRAW  (%2.2d-%2.2d):', [Game.PieceCount[BLACK], Game.PieceCount[WHITE]]);
    end
  else
    Result := 'NOT FINISHED:';
  for TurnNo := 1 to Game.PlayedTurns + 1 do
  begin
    M := Game.MoveOf(BLACK, TurnNo);
    if M = '' then Break;
    Result := Result + ' ' + M;
    M := Game.MoveOf(WHITE, TurnNo);
    if M = '' then Break;
    Result := Result + ' ' + M;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  MemoryStatus: TMemoryStatus;
begin
  MemoryStatus.dwLength := SizeOf(MemoryStatus);
  GlobalMemoryStatus(MemoryStatus);
  Game.MaxMemory := MulDiv(MemoryStatus.dwTotalPhys, 10, 100);
  Screen.OnActiveFormChange := ActiveScreenFormChange;
  TimePanel.DoubleBuffered := True;
  StateInfo.DoubleBuffered := True;
  HistoryTime.DoubleBuffered := True;
  Opener := BLACK;
  LoadSettings;
  AdjustSize;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  UpdateTitle;
  if ParamCount > 0 then
  begin
    Game.BoardMode := gbmPlay;
    try
      Game.LoadFromFile(ParamStr(1), Application.Title);
    except
      Game.StartNewGame;
      raise;
    end;
  end
  else
    Game.StartNewGame;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Screen.OnActiveFormChange := nil;
  if Assigned(BoardStream) then
    FreeAndNil(BoardStream);
  SetFullScreen(False);
  sndPlaySound(nil, 0);
  SaveSettings;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := IsGameSaved;
end;

procedure TMainForm.ActiveScreenFormChange(Sender: TObject);
begin
  SetFullScreen(False);
  if (Screen.ActiveForm <> Self) and Game.Playing then
  begin
    PausedByDialog := True;
    Game.Paused := True;
  end
  else if (Screen.ActiveForm = Self) and PausedByDialog then
  begin
    PausedByDialog := False;
    Game.Paused := False;
  end;
end;

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if FullScreenMode and (Ord(Key) = VK_ESCAPE) then
  begin
    Key := #0;
    SetFullScreen(False);
  end;
end;

procedure TMainForm.FormCanResize(Sender: TObject;
  var NewWidth, NewHeight: Integer; var Resize: Boolean);
begin
  NewWidth := ClientPanel.Width + (Width - ClientWidth);
  NewHeight := ClientPanel.Height + (Height - ClientHeight);
  if Toolbar.Visible then
  begin
    Inc(NewHeight, Toolbar.Height + 1);
    ClientPanel.Top := Toolbar.Height + 1;
  end
  else
    ClientPanel.Top := 0;
end;

procedure TMainForm.ClientPanelResize(Sender: TObject);
begin
  BoardSetupBar.SetBounds(GameHost.Width, 0, BoardSetupBar.Width, GameHost.Height + 1);
  HistoryPanel.SetBounds(GameHost.Width, 0, HistoryPanel.Width, GameHost.Height + 1);
  HistoryPanel.Realign;
  Toolbar.Width := ClientPanel.Width;
end;

procedure TMainForm.HistoryCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  DefaultDraw := True;
  History.Canvas.Font.Style := Font.Style;
  if Item.Index >= Game.CurrentTurn then
    History.Canvas.Font.Color := clGrayText
  else
    History.Canvas.Font.Color := History.Font.Color;
end;

procedure TMainForm.HistoryCustomDrawSubItem(Sender: TCustomListView;
  Item: TListItem; SubItem: Integer; State: TCustomDrawState;
  var DefaultDraw: Boolean);
var
  TurnNo: Integer;
begin
  DefaultDraw := True;
  if SubItem = 1 then
    TurnNo := Game.CurrentTurnOf[Game.OpenerPlayer]
  else
    TurnNo := Game.CurrentTurnOf[Opponent(Game.OpenerPlayer)];
  if Item.Index + 1 >= TurnNo then
    History.Canvas.Font.Color := clGrayText
  else
    History.Canvas.Font.Color := History.Font.Color;
  History.Canvas.Font.Style := Font.Style;
end;

procedure TMainForm.ThinkIconPaint(Sender: TObject);
var
  IconIndex: Integer;
begin
  IconIndex := ThinkIconIndex mod ThinkIcons.Count;
  if Odd(ThinkIconIndex div ThinkIcons.Count) then
    IconIndex := ThinkIcons.Count - IconIndex - 1;
  ThinkIcons.Draw(ThinkIcon.Canvas,
    (ThinkIcon.ClientWidth - ThinkIcons.Width) div 2,
    (ThinkIcon.ClientHeight - ThinkIcons.Height) div 2,
     IconIndex, dsNormal, itImage, True);
end;

procedure TMainForm.TimerTimer(Sender: TObject);
var
  Time: Cardinal;
  Rect: TRect;
begin
  ElapsedTime.Caption := MillisecondsToStr(Game.CurrentTime, False);
  if Game.Thinking then
  begin
    Inc(ThinkIconIndex);
    ThinkIcon.Visible := True;
    Rect := ThinkIcon.BoundsRect;
    InvalidateRect(ThinkIcon.Parent.Handle, @Rect, False);
  end;
  TimePanel.Update;
  Time := Game.CurrentTimeOf[Game.CurrentPlayer];
  if Game.CurrentPlayer = Game.OpenerPlayer then
    Time1.Caption := MillisecondsToStr(Time, True)
  else
    Time2.Caption := MillisecondsToStr(Time, True);
  HistoryTime.Update;
//  if Game.MemorySize <> 0 then
//    Caption := Format('%.1f MB, %%%.1f',
//      [Game.MemorySize / (1024 * 1024),
//       Game.MemoryUsedSize / Game.MemorySize * 100]);
end;

procedure TMainForm.ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
var
  I: Integer;
begin
  for I := 0 to ActionList.ActionCount - 1 do
    ActionList.UpdateAction(ActionList.Actions[I]);
  btnPause.Visible := ControlPause.Enabled;
  btnResume.Visible := ControlResume.Enabled;
  btnNoMove.Visible := not Game.IsComputerTurn and Game.MustPlayNull;
  btnNoMove.Enabled := Game.Playing;
  Done := True;
end;

procedure TMainForm.ApplicationEventsDeactivate(Sender: TObject);
begin
  SetFullScreen(False);
end;

procedure TMainForm.GamePositionClick(Sender: TObject; Pos: TPosition;
  var Handled: Boolean);
var
  NewPiece: TPiece;
begin
  if not FullScreenMode and (Game.BoardMode = gbmSetup) then
  begin
    Handled := True;
    if btnBlackPiece.Down then
      NewPiece := BLACK
    else if btnWhitePiece.Down then
      NewPiece := WHITE
    else
      NewPiece := EMPTY;
    if Game.Pieces[Pos] <> NewPiece then
      Game.Pieces[Pos] := NewPiece
    else
      Game.Pieces[Pos] := EMPTY;
  end;
end;

procedure TMainForm.GameHistoryChange(Sender: TObject);
begin
  UpdateHistory;
end;

procedure TMainForm.GameThinkEnd(Sender: TObject);
begin
  ThinkIcon.Visible := False;
end;

procedure TMainForm.GamePlayingStateChange(Sender: TObject);
begin
  Timer.Enabled := Game.Playing;
end;

procedure TMainForm.GameBoardModeChange(Sender: TObject);
begin
  UpdateTitle;
  if Game.BoardMode = gbmSetup then
  begin
    btnWhiteTurn.Down := (Game.CurrentPlayer = WHITE);
    btnBlackTurn.Down := (Game.CurrentPlayer <> WHITE);
    TimePanel.Visible := False;
    btnRevertChanges.Visible := Assigned(BoardStream);
    State.Caption := '';
    ClientPanel.AutoSize := False;
    try
      BoardSetupBar.Visible := True;
      HistoryPanel.Visible := False;
      SetupCommands.Visible := True;
      SetupCommands.Left := LeftSpacer.BoundsRect.Right;
    finally
      ClientPanel.AutoSize := True;
    end;
  end
  else
  begin
    ClientPanel.AutoSize := False;
    try
      SetupCommands.Visible := False;
      HistoryPanel.Visible := ShowHistory;
      BoardSetupBar.Visible := False;
    finally
      ClientPanel.AutoSize := True;
    end;
  end;
end;

procedure TMainForm.GameBoardChange(Sender: TObject);
begin
  PiecesCount.Caption := Format(SPiecesCount,
    [Game.PieceCount[BLACK], Game.PieceCount[WHITE]]);
  PiecesCount.Update;
end;

procedure TMainForm.GameTurnChange(Sender: TObject);
begin
  ElapsedTime.Caption := MillisecondsToStr(Game.CurrentTime, False);
  TimePanel.Visible := not Game.IsGameEnded;
  if TimePanel.Visible and (TimePanel.Left > RightSpacer.Left) then
    TimePanel.Left := RightSpacer.Left;
  TimePanel.Update;
  UpdateState;
  PieceImages.GetIcon(2 + Ord(Game.CurrentPlayer = WHITE), TurnIcon.Picture.Icon);
end;

procedure TMainForm.GameSelectionChange(Sender: TObject);
begin
  if Game.IsSelectionComplete then
  begin
    State.Caption := '';
    SuggestionCommands.Visible := True;
    SuggestionCommands.Left := LeftSpacer.BoundsRect.Right;
  end
  else if SuggestionCommands.Visible then
  begin
    SuggestionCommands.Visible := False;
    UpdateState;
  end;
end;

procedure TMainForm.GameEnded(Sender: TObject);
begin
  ReleaseGame(ChangeFileExt(Application.ExeName, '.log'));
  if TGameFinishDialog.Execute(Game.WinnerPlayer, Game.ComputerPlayer) then
    GameNew.Execute;
end;

procedure TMainForm.GameResize(Sender: TObject);
begin
  if not FullScreenMode then
  begin
    ClientPanel.AutoSize := False;
    GameHost.ClientWidth := Game.Width + 1;
    GameHost.ClientHeight := StateInfo.Height + Game.Height;
    HistoryPanel.Left := GameHost.Width;
    HistoryPanel.Height := GameHost.Height + 1;
    BoardSetupBar.Left := GameHost.Width;
    BoardSetupBar.Height := GameHost.Height + 1;
    ClientPanel.AutoSize := True;
  end;
  with Game.BoardBounds do
  begin
    PiecesCount.Left := Left;
    PiecesCount.Top := Bottom + (Game.BoardMarginBottom - PiecesCount.Height) div 2;
  end;
end;

procedure TMainForm.GameNullMove(Sender: TObject);
begin
  if ControlEnableSounds.Checked then
    sndPlaySound('NULL_MOVE', SND_NODEFAULT or SND_ASYNC or SND_RESOURCE);
end;

procedure TMainForm.GameMove(Sender: TObject; Pos: TPosition);
begin
  if ControlEnableSounds.Checked then
    sndPlaySound('MOVE', SND_NODEFAULT or SND_ASYNC or SND_RESOURCE);
end;

procedure TMainForm.GameNewExecute(Sender: TObject);
begin
  if IsGameSaved then
    Game.StartNewGame;
end;

procedure TMainForm.GameOpenExecute(Sender: TObject);
begin
  SetFullScreen(False);
  if IsGameSaved then
  begin
    if Game.Playing then
    begin
      PausedByDialog := True;
      Game.Paused := True;
    end;
    try
      if OpenDialog.Execute then
        Game.LoadFromFile(OpenDialog.FileName, Application.Title);
    finally
      if PausedByDialog then
      begin
        PausedByDialog := False;
        Game.Paused := False;
      end;
    end;
  end;
end;

procedure TMainForm.GameSaveExecute(Sender: TObject);
begin
  SetFullScreen(False);
  if Game.Playing then
  begin
    PausedByDialog := True;
    Game.Paused := True;
  end;
  try
    if SaveDialog.Execute then
      Game.SaveToFile(SaveDialog.FileName, Application.Title);
  finally
    if PausedByDialog then
    begin
      PausedByDialog := False;
      Game.Paused := False;
    end;
  end;
end;

procedure TMainForm.GameExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.HelpAboutExecute(Sender: TObject);
begin
  TAboutDialog.Execute;
end;

procedure TMainForm.HistoryFowardUpdate(Sender: TObject);
begin
  HistoryFoward.Enabled := Game.CanMoveForward;
end;

procedure TMainForm.HistoryFowardExecute(Sender: TObject);
begin
  Game.MoveForward;
end;

procedure TMainForm.HistoryBackwardUpdate(Sender: TObject);
begin
  HistoryBackward.Enabled := Game.CanMoveBackward;
end;

procedure TMainForm.HistoryBackwardExecute(Sender: TObject);
begin
  Game.MoveBackward;
end;

procedure TMainForm.LevelEasyUpdate(Sender: TObject);
begin
  LevelEasy.Checked := (Game.SearchDepth = SearchDepths[1]);
end;

procedure TMainForm.LevelEasyExecute(Sender: TObject);
begin
  Game.SearchDepth := SearchDepths[1];
  UpdateTitle;
end;

procedure TMainForm.LevelMediumUpdate(Sender: TObject);
begin
  LevelMedium.Checked := (Game.SearchDepth = SearchDepths[2]);
end;

procedure TMainForm.LevelMediumExecute(Sender: TObject);
begin
  Game.SearchDepth := SearchDepths[2];
  UpdateTitle;
end;

procedure TMainForm.LevelDifficultUpdate(Sender: TObject);
begin
  LevelDifficult.Checked := (Game.SearchDepth = SearchDepths[3]);
end;

procedure TMainForm.LevelDifficultExecute(Sender: TObject);
begin
  Game.SearchDepth := SearchDepths[3];
  UpdateTitle;
end;

procedure TMainForm.LevelCustomUpdate(Sender: TObject);
begin
  LevelCustom.Checked := not (Game.SearchDepth in [SearchDepths[1], SearchDepths[2], SearchDepths[3]]);
end;

procedure TMainForm.LevelCustomExecute(Sender: TObject);
var
  SearchDepth: Integer;
begin
  SearchDepth := Game.SearchDepth;
  if TSearchDepthDialog.Execute(SearchDepth) then
  begin
    Game.SearchDepth := SearchDepth;
    UpdateTitle;
  end;
end;

procedure TMainForm.ComputerPlaysNoneUpdate(Sender: TObject);
begin
  ComputerPlaysNone.Checked := (Game.ComputerPlayer = NONE);
end;

procedure TMainForm.ComputerPlaysNoneExecute(Sender: TObject);
begin
  Game.ComputerPlayer := NONE;
  UpdateTitle;
end;

procedure TMainForm.ComputerPlaysBlackUpdate(Sender: TObject);
begin
  ComputerPlaysBlack.Checked := (Game.ComputerPlayer = BLACK);
end;

procedure TMainForm.ComputerPlaysBlackExecute(Sender: TObject);
begin
  Game.ComputerPlayer := BLACK;
  UpdateTitle;
end;

procedure TMainForm.ComputerPlaysWhiteUpdate(Sender: TObject);
begin
  ComputerPlaysWhite.Checked := (Game.ComputerPlayer = WHITE);
end;

procedure TMainForm.ComputerPlaysWhiteExecute(Sender: TObject);
begin
  Game.ComputerPlayer := WHITE;
  UpdateTitle;
end;

procedure TMainForm.ComputerPlaysBothUpdate(Sender: TObject);
begin
  ComputerPlaysBoth.Checked := (Game.ComputerPlayer = BOTH_PLAYERS);
end;

procedure TMainForm.ComputerPlaysBothExecute(Sender: TObject);
begin
  Game.ComputerPlayer := BOTH_PLAYERS;
  UpdateTitle;
end;

procedure TMainForm.ComputerPlayNowUpdate(Sender: TObject);
begin
  ComputerPlayNow.Enabled := Game.Thinking;
end;

procedure TMainForm.ComputerPlayNowExecute(Sender: TObject);
begin
  Game.PlayComputerTurnNow;
end;

procedure TMainForm.HistoryShowUpdate(Sender: TObject);
begin
  HistoryShow.Checked := ShowHistory;
  HistoryShow.Enabled := not BoardSetupBar.Visible;
end;

procedure TMainForm.HistoryShowExecute(Sender: TObject);
begin
  ShowHistory := not ShowHistory;
  HistoryPanel.Visible := ShowHistory;
end;

procedure TMainForm.BoardSizeSmallUpdate(Sender: TObject);
begin
  BoardSizeSmall.Checked := (Game.SquareSize = SquareSizes[1]);
end;

procedure TMainForm.BoardSizeSmallExecute(Sender: TObject);
begin
  Game.SquareSize := SquareSizes[1];
end;

procedure TMainForm.BoardSizeMediumUpdate(Sender: TObject);
begin
  BoardSizeMedium.Checked := (Game.SquareSize = SquareSizes[2]);
end;

procedure TMainForm.BoardSizeMediumExecute(Sender: TObject);
begin
  Game.SquareSize := SquareSizes[2];
end;

procedure TMainForm.BoardSizeLargeUpdate(Sender: TObject);
begin
  BoardSizeLarge.Checked := (Game.SquareSize = SquareSizes[3]);
end;

procedure TMainForm.BoardSizeLargeExecute(Sender: TObject);
begin
  Game.SquareSize := SquareSizes[3];
end;

procedure TMainForm.HistoryMoveToBlackUpdate(Sender: TObject);
begin
  HistoryMoveToBlack.Enabled := Game.CanRetrieve(BLACK, History.ItemIndex + 1);
end;

procedure TMainForm.HistoryMoveToBlackExecute(Sender: TObject);
begin
  Game.Retrieve(BLACK, History.ItemIndex + 1);
end;

procedure TMainForm.HistoryMoveToWhiteUpdate(Sender: TObject);
begin
  HistoryMoveToWhite.Enabled := Game.CanRetrieve(WHITE, History.ItemIndex + 1);
end;

procedure TMainForm.HistoryMoveToWhiteExecute(Sender: TObject);
begin
  Game.Retrieve(WHITE, History.ItemIndex + 1);
end;

procedure TMainForm.ComputerSuggestUpdate(Sender: TObject);
begin
  ComputerSuggest.Enabled := Game.Playing and not Game.IsComputerTurn;
end;

procedure TMainForm.ComputerSuggestExecute(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try
    Game.SelectMove(Game.SuggestMove);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainForm.btnPlaySelectionClick(Sender: TObject);
begin
  Game.PlaySelection;
end;

procedure TMainForm.btnClearSelectionClick(Sender: TObject);
begin
  Game.ClearSelection;
end;

procedure TMainForm.ControlPauseUpdate(Sender: TObject);
begin
  ControlPause.Enabled := Game.Playing;
end;

procedure TMainForm.ControlPauseExecute(Sender: TObject);
begin
  Game.Paused := True;
end;

procedure TMainForm.ControlResumeUpdate(Sender: TObject);
begin
  ControlResume.Enabled := (Game.BoardMode = gbmPlay) and Game.Paused and not Game.IsGameEnded;
end;

procedure TMainForm.ControlResumeExecute(Sender: TObject);
begin
  Game.Paused := False;
end;

procedure TMainForm.GameSetupBoardUpdate(Sender: TObject);
begin
  GameSetupBoard.Enabled := (Game.BoardMode <> gbmSetup);
end;

procedure TMainForm.GameSetupBoardExecute(Sender: TObject);
begin
  if Assigned(BoardStream) then
    BoardStream.Clear
  else
    BoardStream := TMemoryStream.Create;
  Game.SaveToStream(BoardStream);
  BoardStream.Position := 0;
  Game.BoardMode := gbmSetup;
end;

procedure TMainForm.btnApplyChangesClick(Sender: TObject);
begin
  FreeAndNil(BoardStream);
  if btnBlackTurn.Down then
    Game.CurrentPlayer := BLACK
  else
    Game.CurrentPlayer := WHITE;
  Game.BoardMode := gbmPlay;
end;

procedure TMainForm.btnRevertChangesClick(Sender: TObject);
begin
  Game.BoardMode := gbmPlay;
  Game.LoadFromStream(BoardStream);
  FreeAndNil(BoardStream);
end;

procedure TMainForm.btnClearBoardClick(Sender: TObject);
begin
  Game.ClearBoard;
  btnBlackTurn.Down := True;
  btnWhiteTurn.Down := False;
end;

procedure TMainForm.btnNoMoveClick(Sender: TObject);
begin
  Game.PlayNullMove;
end;

procedure TMainForm.ViewSelectablePositionsUpdate(Sender: TObject);
begin
  ViewSelectablePositions.Checked := Game.MarkSelectableSquares;
end;

procedure TMainForm.ViewSelectablePositionsExecute(Sender: TObject);
begin
  Game.MarkSelectableSquares := not Game.MarkSelectableSquares;
end;

procedure TMainForm.HelpRulesExecute(Sender: TObject);
const
  URL = 'http://www.pressmangames.com/instructions/instruct_othello.html';
begin
  ShellExecute(Handle, 'open', URL, nil, nil, SW_NORMAL);
end;

procedure TMainForm.ViewToolbarUpdate(Sender: TObject);
begin
  ViewToolbar.Checked := Toolbar.Visible;
end;

procedure TMainForm.ViewToolbarExecute(Sender: TObject);
begin
  Toolbar.Visible := not Toolbar.Visible;
  AdjustSize;
end;

procedure TMainForm.HistoryShowTimesExecute(Sender: TObject);
begin
  HistoryShowTimes.Checked := not HistoryShowTimes.Checked;
  UpdateHistory;
end;

procedure TMainForm.ViewFullScreenExecute(Sender: TObject);
begin
  SetFullScreen(True);
end;

procedure TMainForm.ControlEnableSoundsExecute(Sender: TObject);
begin
  ControlEnableSounds.Checked := not ControlEnableSounds.Checked;
end;

procedure TMainForm.HelpHomePageExecute(Sender: TObject);
const
  URL = 'http://www.delphiarea.com/products/applications/othello/';
begin
  ShellExecute(Handle, 'open', URL, nil, nil, SW_NORMAL);
end;

procedure TMainForm.HistoryFirstUpdate(Sender: TObject);
begin
  HistoryFirst.Enabled := Game.CanMoveBackward;
end;

procedure TMainForm.HistoryFirstExecute(Sender: TObject);
begin
  Game.MoveToFirst;
end;

procedure TMainForm.HistoryLastUpdate(Sender: TObject);
begin
  HistoryLast.Enabled := Game.CanMoveForward;
end;

procedure TMainForm.HistoryLastExecute(Sender: TObject);
begin
  Game.MoveToLast;
end;

procedure TMainForm.Rotate000Update(Sender: TObject);
begin
  Rotate000.Checked := (Game.BoardAngle = 0);
end;

procedure TMainForm.Rotate000Execute(Sender: TObject);
begin
  Game.BoardAngle := 0;
end;

procedure TMainForm.Rotate090Update(Sender: TObject);
begin
  Rotate090.Checked := (Game.BoardAngle = 90);
end;

procedure TMainForm.Rotate090Execute(Sender: TObject);
begin
  Game.BoardAngle := 90;
end;

procedure TMainForm.Rotate180Update(Sender: TObject);
begin
  Rotate180.Checked := (Game.BoardAngle = 180);
end;

procedure TMainForm.Rotate180Execute(Sender: TObject);
begin
  Game.BoardAngle := 180;
end;

procedure TMainForm.Rotate270Update(Sender: TObject);
begin
  Rotate270.Checked := (Game.BoardAngle = 270);
end;

procedure TMainForm.Rotate270Execute(Sender: TObject);
begin
  Game.BoardAngle := 270;
end;

procedure TMainForm.GameMemoryOptionsExecute(Sender: TObject);
var
  MaxSize: Cardinal;
begin
  MaxSize := Game.MaxMemory div OneMB;
  if TMemoryOptionsDialog.Execute(MaxSize) then
    Game.MaxMemory := MaxSize * OneMB;
end;

procedure TMainForm.RotateClockwiseExecute(Sender: TObject);
begin
  Game.BoardAngle := Game.BoardAngle + 90;
end;

procedure TMainForm.RotateConterClockwiseExecute(Sender: TObject);
begin
  Game.BoardAngle := Game.BoardAngle - 90;
end;

procedure TMainForm.HistoryCopyUpdate(Sender: TObject);
begin
  HistoryCopy.Enabled := (History.Items.Count > 0);
end;

procedure TMainForm.HistoryCopyExecute(Sender: TObject);
begin
  Clipboard.AsText := MatchAsString;
end;

end.
