//------------------------------------------------------------------------------
//
// DA Othello - About Box
//
// Copyright (c) 2005 Kambiz R. Khojasteh
// All rights reserved.
//
//------------------------------------------------------------------------------

unit dlgAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg;

type
  TAboutDialog = class(TForm)
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    Title: TImage;
    ImagePanel: TPanel;
    Image: TImage;
    HomePage: TLabel;
    Devider2: TBevel;
    procedure LinkClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    class procedure Execute;
  end;

implementation

{$R *.dfm}

uses
  ShellAPI;

{ Helper Functions }

function GetVersionInfo(const FileName, ValueName: String): String;
var
  Trans: PCardinal;
  VerInfoSize, ValSize, Dummy: Cardinal;
  VerInfo, Value: Pointer;
  TransStr, InfoStr: String;
begin
  Result := '';
  VerInfoSize := GetFileVersioninfoSize(PChar(FileName), Dummy);
  if VerInfoSize <> 0 then
  begin
    GetMem(VerInfo, VerInfoSize);
    try
      if GetFileVersionInfo(PChar(FileName), Dummy, VerInfoSize, VerInfo) then
      begin
        VerQueryValue(VerInfo, '\VarFileInfo\Translation', Pointer(Trans), valSize);
        TransStr := IntToHex(LoWord(Trans^), 4) + IntToHex(HiWord(Trans^), 4);
        if not SameText(ValueName, 'Language') then
        begin
          InfoStr := '\StringFileInfo\' + TransStr + '\' + ValueName;
          if VerQueryValue(VerInfo, PChar(InfoStr), Value, ValSize) then
            SetString(Result, PChar(Value), ValSize - 1);
        end
        else
        begin
          SetLength(Result, 256);
          VerLanguageName(LoWord(Trans^), PChar(Result), Length(Result));
          SetLength(Result, StrLen(PChar(Result)));
        end;
      end;
    finally
      FreeMem(VerInfo);
    end;
  end;
end;

{ TAboutDialog }

class procedure TAboutDialog.Execute;
begin
  with Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TAboutDialog.FormCreate(Sender: TObject);
begin
  Version.Caption := Format(Version.Caption,
    [GetVersionInfo(Application.ExeName, 'ProductVersion')]);
  Version.Left := Title.Left + Title.Width - Version.Width - 8;
  Copyright.Caption := GetVersionInfo(Application.ExeName, 'LegalCopyright');
end;

procedure TAboutDialog.FormClick(Sender: TObject);
begin
  Close;
end;

procedure TAboutDialog.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Ord(Key) in [VK_ESCAPE, VK_RETURN] then
  begin
    Key := #0;
    Close;
  end;
end;

procedure TAboutDialog.LinkClick(Sender: TObject);
begin
  ShellExecute(0, 'open', PChar(TControl(Sender).Hint), nil, nil, SW_NORMAL);
end;

end.
